/**
 * Looks for Tension2Go directory 
 * @param fileSystem filesystem of mobile device
 */
var disclaimerAccepted=false;

function gotReadFS(fileSystem) {
	fileSystem.root.getDirectory("Tension2Go", {create: false}, successDirectory, failDirectory);
}

/**
 * Searches for config file ("settings.jun") in given parent directory 
 * @param parent current directory
 */
function successDirectory(parent) {
	parent.getFile("settings.jun", {create: false}, gotReadFileEntry, failRead);
}

/**
 * Opens file for reading
 * @param fileEntry
 */
function gotReadFileEntry(fileEntry) {
    fileEntry.file(readAsText, failRead);
}

/**
 * Reads file as text file
 * @param file 
 */
function readAsText(file) {
    var reader = new FileReader();
    
    //Trigger event after text file content is loaded.
    reader.onloadend = function(evt) {
        var textFromReader=reader.result;
        var stringFromReader=textFromReader.toString();
        var disclaimer = getLocalizedTextWithLang("disclaimerText1",localization).toString();
        var buttonText = getLocalizedTextWithLang("buttonAcceptDecline",localization).toString();
        if (textFromReader==null){
        	navigator.notification.confirm(disclaimer, acceptCallback, 'Disclaimer', buttonText);       }      
        else if(textFromReader=="2"){
        	console.log("Everything alright!");
        	disclaimerAccepted=true;
        	//navigator.notification.alert('Disclaimer schon akzeptiert.',function test(){},'OK', 'ok');
        	
        }
        else{    	
        	navigator.notification.confirm(disclaimer, acceptCallback, 'Disclaimer', buttonText);
        }
        
    };
    reader.readAsText(file);
}


/**
 * Disclaimer accepted from disclaimer page 
 */
function acceptDisclaimer(){
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, changeDataDirectory, failCompletly);
		disclaimerAccepted=true;
}

/**
 * Disclaimer callback from start notification
 * @param numberOfButton
 */
function acceptCallback(numberOfButton){

	if (numberOfButton==1){
		window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, changeDataDirectory, failCompletly);
		disclaimerAccepted=true;
	}
	else
	{
		disclaimerAccepted=false;
	}
}

/**
 * Searches for directory "Tension2Go" in filesystem
 * @param fileSystem
 */
function changeDataDirectory(fileSystem){
	fileSystem.root.getDirectory("Tension2Go", {create: false, exclusive: true}, changeDataFile, failCompletly);
}

/**
 * Searches for settings file in parent folder
 * @param parent
 */
function changeDataFile(parent){
	parent.getFile("settings.jun", {create: false}, writeFileEntry, fileNotFound);
}


/**
 * Error message file not found
 */
function fileNotFound(){
	alert("file not found!!");
}

function alertCallback(){
	console.log("just a test");
}
        
function gotWriteFS(fileSystem) {
    fileSystem.root.getFile("settings.jun", {create: true, exclusive: true}, gotWriteFileEntry, failRead);
}

function gotWriteFileEntry(fileEntry) {
	//alert("ins");
    fileEntry.createWriter(gotFileWriter, failRead);
}

function gotFileWriter(writer) {
    var disclaimer = getLocalizedTextWithLang("disclaimerText1",localization).toString();
    var buttonText = getLocalizedTextWithLang("buttonAcceptDecline",localization).toString();
	navigator.notification.confirm(disclaimer, acceptCallback, 'Disclaimer', buttonText);
	writer.write("0");
    
}

function writeFileEntry(fileEntry) {
    fileEntry.createWriter(fileWriter, failRead);
}

function fileWriter(writer) {
    writer.write("2");
}

function gotDeleteFS(fileSystem) {
	fileSystem.root.getFile("settings.jun", null, gotDeleteFileEntry, failRead);
}

function gotDeleteFileEntry(fileEntry) {
	fileEntry.remove(successDelete, failDelete);
}

function failRead(evt) {
    navigator.notification.alert("File not found", alertCallback, 'file Error', 'ok');
}

function successDelete(entry) {
    console.log("Removal succeeded");
}

function failDelete(error) {
	console.log('Error removing file: ' + error.code);
}

function successDirectoryCreate(parent) {
	parent.getFile("settings.jun", {create: true, exclusive: true}, gotWriteFileEntry, failCompletly);
}

function failDirectory(error) {
	window.requestFileSystem(LocalFileSystem.PERSISTENT, 0, createAppDirectory, failCompletly);
	
	//Callbacktest
	//testCallback(callBackTest);
}

function callBackTest(someText){
	alert(someText);
}

function testCallback(callback){
	callback("Callback im Fail geto");
}

function createAppDirectory(fileSystem){
	fileSystem.root.getDirectory("Tension2Go", {create: true, exclusive: true}, successDirectoryCreate, failCompletly);
}

function failCompletly(){
	navigator.notification.alert('Unable to access file system.',function test(){},'file Error', 'ok');
}
//
